//////////////////////////////////////////
// FullscreenTest.cpp
// 710020-1140x
//
// History
// =======
// -11401 
// Feb 24, 03 : ctacke
//  Initial release 
//////////////////////////////////////////
#include <windows.h>
#include <commctrl.h>

#define IDC_CMDBAR 1

HWND		hwndMain;
TCHAR		pszAppName[]	= _T("FullscreenTest");

LRESULT CALLBACK MainWndProc(HWND,UINT,WPARAM,LPARAM);
BOOL FullScreen(HWND hwnd, BOOL mode);

int WINAPI WinMain(
			HINSTANCE hInstance, 
			HINSTANCE hPrevInstance, 
			LPTSTR lpCmdLine,
			int nCmdShow)
{
	MSG			msg;
	WNDCLASS	wndClass;
//	RECT		screenRECT;

	RETAILMSG(TRUE, (_T("----- Starting FullscreenTest.exe -----\r\n")));

	/* Register the main window class */
	wndClass.style         = 0;
	wndClass.lpfnWndProc   = MainWndProc;
	wndClass.cbClsExtra    = 0;
	wndClass.cbWndExtra    = 0;
	wndClass.hInstance     = hInstance;
	wndClass.hIcon         = NULL;
	wndClass.hCursor       = NULL;
	wndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wndClass.lpszMenuName  = NULL;
	wndClass.lpszClassName = pszAppName;

    ::RegisterClass(&wndClass);


    hwndMain = ::CreateWindowEx(
        WS_EX_NODRAG,
        pszAppName,
        TEXT("FullScreen Test"),
        WS_VISIBLE | WS_BORDER,
        0,0,
        640,
        100,
        NULL,
        NULL,
        hInstance,
        NULL
        );

	// add a close button
	HWND hwndCB = CommandBar_Create(hInstance, hwndMain, IDC_CMDBAR);
	CommandBar_AddAdornments(hwndCB, 0, 0);

	UpdateWindow(hwndMain);

	// wait to show the non-full-screen form first
	Sleep(3000);

	// make the app fullscreen
	FullScreen(hwndMain, TRUE);

	Sleep(3000);

	// make the app fullscreen
	FullScreen(hwndMain, FALSE);

	// main message pump
    while (::GetMessage(&msg, NULL, 0, 0) == TRUE)
	{
        ::TranslateMessage(&msg);
        ::DispatchMessage(&msg); 
	}

	RETAILMSG(TRUE, (_T("----- Ending FullscreenTest.exe -----\r\n")));

	return 0;
}

LRESULT CALLBACK MainWndProc(
    HWND hwnd,
    UINT message,
    WPARAM wParam,
    LPARAM lParam)
{
	switch(message)
	{
		case WM_DESTROY:
			PostQuitMessage(0);
		break;
		default:
			return (DefWindowProc(hwnd, message, wParam, lParam));
	}

    return (0);
}

BOOL FullScreen(HWND hwnd, BOOL mode)
{
	BOOL	success		= TRUE;
	RECT	screenRECT;
	HWND	hwndTaskBar	= NULL;

	// validate handle
	if(!IsWindow(hwnd))
		return FALSE;

	// get work area size
	SystemParametersInfo(SPI_GETWORKAREA, sizeof(RECT), &screenRECT, 0);

	// Find the Taskbar window handle
	hwndTaskBar = FindWindow(TEXT("HHTaskBar"), NULL);

	if(mode)
	{

		if(hwndTaskBar)
		{
			RECT rectTaskBar;

			// get the task bar bounds
			GetWindowRect(hwndTaskBar, &rectTaskBar);

			// hide the task bar
			ShowWindow(hwndTaskBar, SW_HIDE);

			::SetForegroundWindow(hwnd);

			// update our screen work area
			screenRECT.bottom += (rectTaskBar.bottom - rectTaskBar.top);
		}

		SystemParametersInfo(SPI_SETWORKAREA, sizeof(RECT), &screenRECT, 0);
	}
	else
	{
		if(hwndTaskBar)
		{
			RECT rectTaskBar;

			// get the task bar bounds
			GetWindowRect(hwndTaskBar, &rectTaskBar);

			// hide the task bar
			ShowWindow(hwndTaskBar, SW_SHOW);

			// update our screen work area
			screenRECT.bottom -= (rectTaskBar.bottom - rectTaskBar.top);
		}

	}

	SystemParametersInfo(SPI_SETWORKAREA, sizeof(RECT), &screenRECT, 0);

	// update the screen
	MoveWindow(hwnd, 0, 0, screenRECT.right, screenRECT.bottom, TRUE);
	InvalidateRect(NULL, &screenRECT, TRUE);
	UpdateWindow(hwnd);
		
	return success;
}
